<template>
  <div>
    <v-row dense>
      <GCol cols="12">
        <GTextField
          v-model="value._attr.refType"
          i18n="dcc.common.attributes.refType"
          attr-ref-type
        />
        <DccLocalizedTextBlock
          v-model="value.name"
          i18n="dcc.common.quantityType.name"
        />
      </GCol>
      <GCol v-if="!quantityElementPresent">
        <v-alert class="mt-2 mb-0" color="warning" icon="warning">
          {{ $t("dcc.common.quantityType.noQuantityWarning") }}
        </v-alert>
      </GCol>
    </v-row>
    <div class="mt-4">
      <Constant
        v-if="value.constant"
        v-model="value.constant"
        level="second"
        card
        optional
        @delete="removeElement('constant')"
      />
      <Real
        v-if="value.real"
        v-model="value.real"
        level="second"
        card
        optional
        @delete="removeElement('real')"
      />
      <RealListXMLList
        v-if="value.realListXMLList"
        v-model="value.realListXMLList"
        level="second"
        card
        optional
        @delete="removeElement('realListXMLList')"
      />
      <Hybrid
        v-if="value.hybrid"
        v-model="value.hybrid"
        level="second"
        card
        optional
        @delete="removeElement('hybrid')"
      />
      <RichContent
        v-if="value.noQuantity"
        v-model="value.noQuantity"
        i18n="dcc.common.richContentType.noQuantity.title"
        optional
        level="second"
        @delete="removeElement('noQuantity')"
      />
      <CharsXMLList
        v-if="value.charsXMLList"
        v-model="value.charsXMLList"
        optional
        level="second"
        @delete="removeElement('charsXMLList')"
      />
    </div>
    <UsedMethodList
      v-if="value.usedMethods"
      id="usedMethodListType"
      v-model="value.usedMethods"
      level="second"
      class="mt-4"
      optional
      @delete="removeElement('usedMethods')"
    />
    <SoftwareList
      v-if="value.usedSoftware"
      id="softwareListType"
      v-model="value.usedSoftware"
      level="second"
      class="mt-4"
      optional
      @delete="removeElement('usedSoftware')"
    />
    <MeasuringEquipmentList
      v-if="value.measuringEquipments"
      id="measuringEquipmentListType"
      v-model="value.measuringEquipments"
      level="second"
      class="mt-4"
      optional
      @delete="removeElement('measuringEquipments')"
    />
    <InfluenceConditionList
      v-if="value.influenceConditions"
      id="influenceConditionListType"
      v-model="value.influenceConditions"
      level="second"
      class="mt-4"
      optional
      @delete="removeElement('influenceConditions')"
    />
    <StatementList
      v-if="value.measurementMetaData"
      id="measurementMetaDataListType"
      v-model="value.measurementMetaData"
      i18n-base="dcc.common.measurementMetaDataListType"
      class="mt-4"
      level="second"
      optional
      item-key="metaData"
      @delete="removeElement('measurementMetaData')"
    />
  </div>
</template>

<script>
import {
  RealQuantityType,
  RealListXMLListType,
  ConstantQuantityType,
  HybridType,
  UsedMethodListType,
  SoftwareListType,
  InfluenceConditionListType,
  MeasuringEquipmentListType,
  MeasurementMetaDataListType,
  RichContentType,
  DCCXMLList,
} from "@d-ptb/dcc-js";
import { validatableMixin } from "../../Mixins/validatableMixin";
import { insertIf } from "~/assets/util/general";
import GTextField from "~/components/App/Form/gTextField";
import DccLocalizedTextBlock from "~/components/App/Form/XML/DccLocalizedTextBlock";
import Real from "~/components/D-SI/Real";
import Hybrid from "~/components/D-SI/Hybrid";
import RealListXMLList from "~/components/D-SI/RealListXMLList";
import Constant from "~/components/D-SI/Constant";
import RichContent from "~/components/DCC/Common/RichContent";
import CharsXMLList from "@/components/DCC/Common/CharsXMLList";
import StatementList from "~/components/DCC/Common/StatementList";
import UsedMethodList from "~/components/DCC/Common/UsedMethodList";
import SoftwareList from "~/components/DCC/Common/SoftwareList";
import MeasuringEquipmentList from "~/components/DCC/MeasurementResults/MeasuringEquipmentList";
import InfluenceConditionList from "~/components/DCC/MeasurementResults/InfluenceConditionList";
import GCol from "~/components/App/Common/GCol";

export default {
  name: "Quantity",
  components: {
    GCol,
    RealListXMLList,
    Hybrid,
    Real,
    Constant,
    RichContent,
    CharsXMLList,
    DccLocalizedTextBlock,
    GTextField,
    MeasuringEquipmentList,
    SoftwareList,
    StatementList,
    UsedMethodList,
    InfluenceConditionList,
  },
  mixins: [validatableMixin],
  props: {
    value: Object,
    updateAvailableElements: Function,
    primitive: {
      type: Boolean,
      default: false,
    },
  },
  computed: {
    availableElements() {
      return [
        {
          title: this.$t(`dcc.common.quantityType.dsiQuantity.title`),
          elements: this.availableDSIQuantityElements,
        },
        {
          title: this.$t(`dcc.common.quantityType.dccQuantity.title`),
          elements: this.availableDCCQuantityElements,
        },
        {
          title: this.$t(`dcc.common.quantityType.further.title`),
          elements: this.availableAdditionalDCCElements,
        },
      ];
    },
    availableDSIQuantityElements() {
      return [
        "constant",
        "real",
        "realListXMLList",
        "hybridConstant",
        "hybridReal",
        "hybridRealListXMLList",
      ]
        .filter((x) => !this.blackListDSIAndDCCElements.includes(x))
        .map((x) => {
          return {
            text: this.$t(`d_si.${x}.title`),
            value: x,
            addElement: () => this.addElement(x),
          };
        });
    },
    availableDCCQuantityElements() {
      return ["noQuantity", "charsXMLList"]
        .filter((x) => !this.blackListDSIAndDCCElements.includes(x))
        .map((x) => {
          return {
            text: this.$t(`dcc.common.quantityType.${x}.title`),
            value: x,
            addElement: () => this.addElement(x),
          };
        });
    },
    availableAdditionalDCCElements() {
      if (this.primitive) return [];
      return [
        "usedMethodListType",
        "measuringEquipmentListType",
        "softwareListType",
        "influenceConditionListType",
        "measurementMetaDataListType",
      ]
        .filter((x) => !this.blacklistAdditionalDCCElements.includes(x))
        .map((x) => {
          return {
            text: this.$t(`dcc.common.${x}.title`),
            value: x,
            addElement: () => this.addElement(x),
          };
        });
    },
    blackListDSIAndDCCElements() {
      return [
        ...insertIf(
          this.value.constant ||
            this.value.real ||
            this.value.realListXMLList ||
            this.value.hybrid ||
            this.value.noQuantity ||
            this.value.charsXMLList,
          "constant",
          "real",
          "realListXMLList",
          "hybridConstant",
          "hybridReal",
          "hybridRealListXMLList",
          "noQuantity",
          "charsXMLList"
        ),
      ];
    },
    blacklistAdditionalDCCElements() {
      return [
        ...insertIf(this.value.usedMethods, "usedMethodListType"),
        ...insertIf(
          this.value.measuringEquipments,
          "measuringEquipmentListType"
        ),
        ...insertIf(this.value.usedSoftware, "softwareListType"),
        ...insertIf(
          this.value.influenceConditions,
          "influenceConditionListType"
        ),
        ...insertIf(
          this.value.measurementMetaData,
          "measurementMetaDataListType"
        ),
      ];
    },
    quantityElementPresent() {
      return !!(
        this.value.constant ||
        this.value.real ||
        this.value.realListXMLList ||
        this.value.hybrid ||
        this.value.noQuantity ||
        this.value.charsXMLList
      );
    },
    customRules() {
      return [() => this.quantityElementPresent];
    },
  },
  watch: {
    "value.constant"() {
      this.validate();
    },
    "value.real"() {
      this.validate();
    },
    "value.realListXMLList"() {
      this.validate();
    },
    "value.hybrid"() {
      this.validate();
    },
    availableElements: {
      handler() {
        this.updateAvailableElements(this.availableElements);
      },
      immediate: true,
      deep: true,
    },
  },
  methods: {
    addElement(element) {
      switch (element) {
        case "constant":
          this.$set(this.value, "constant", new ConstantQuantityType());
          break;
        case "real":
          this.$set(this.value, "real", new RealQuantityType());
          break;
        case "realListXMLList":
          this.$set(this.value, "realListXMLList", new RealListXMLListType());
          break;
        case "hybridConstant":
          this.$set(this.value, "hybrid", new HybridType({ constant: [] }));
          break;
        case "hybridReal":
          this.$set(this.value, "hybrid", new HybridType({ real: [] }));
          break;
        case "hybridRealListXMLList":
          this.$set(
            this.value,
            "hybrid",
            new HybridType({ realListXMLList: [] })
          );
          break;
        case "noQuantity":
          this.$set(this.value, "noQuantity", new RichContentType());
          break;
        case "charsXMLList":
          this.$set(this.value, "charsXMLList", new DCCXMLList());
          break;
        case "usedMethodListType":
          this.$set(this.value, "usedMethods", new UsedMethodListType());
          this.scrollToElement(element);
          break;
        case "measuringEquipmentListType":
          this.$set(
            this.value,
            "measuringEquipments",
            new MeasuringEquipmentListType()
          );
          this.scrollToElement(element);
          break;
        case "softwareListType":
          this.$set(this.value, "usedSoftware", new SoftwareListType());
          this.scrollToElement(element);
          break;
        case "influenceConditionListType":
          this.$set(
            this.value,
            "influenceConditions",
            new InfluenceConditionListType()
          );
          this.scrollToElement(element);
          break;
        case "measurementMetaDataListType":
          this.$set(
            this.value,
            "measurementMetaData",
            new MeasurementMetaDataListType()
          );
          this.scrollToElement(element);
          break;
      }
    },
    scrollToElement(element) {
      this.$nextTick(() => {
        const elt = document.getElementById(element);
        elt.scrollIntoView({ behavior: "smooth" });
      });
    },
    removeElement(type) {
      confirm(this.$t(`dcc.common.quantityType.${type}.confirmRemove`)) &&
        this.$delete(this.value, type);
    },
  },
};
</script>
